function aa=area(x,a)

%       AA=AREA(X,A) returns the "area" of a fuzzy set A defined on
%       universe X. This function is used for the "weighted singleton
%       coa" defuzzification.
%
%       See also COA, COAW, MOM.

% (c) Robert Babuska, March 1993

x = x(:); a = a(:);
[xm,xn] = size(x);

dx = [x(2:xm,:); x(xm,:)] - x;
if (xn == 1)   dx = dx * ones(1,length(a(1,:))); end;
da = [a(2:xm,:); a(xm,:)] - a;
aa = sum(dx.*(a+da/2))';

